% plots for "Macro-Finance" 
% This program copied from AFA_Pres_speech/NBER_AP_Crisis, and updated. 
% This does not update all pictures -- only ones used in
% macro finance. 

clear all
close all

x = load('crsp_nyse_new.txt');
caldt = x(:,1);
totval = x(:,2);
usdval  = x(:,3);
sprtrn = x(:,4);
spindx = x(:,5);
vwretd = x(:,6);
vwretx = x(:,7);

[yr,mo,day,crsp_date_number] = decode_date(caldt);

T = size(vwretd,1); 
vwretda = (1+vwretd(1:T-11)).*(1+vwretd(2:T-10)).*(1+vwretd(3:T-9)).*...
          (1+vwretd(4:T-8)).*(1+vwretd(5:T-7)).*(1+vwretd(6:T-6)).*...
          (1+vwretd(7:T-5)).*(1+vwretd(8:T-4)).*(1+vwretd(9:T-3)).*...
          (1+vwretd(10:T-2)).*(1+vwretd(11:T-1)).*(1+vwretd(12:T));

vwretxa = (1+vwretx(1:T-11)).*(1+vwretx(2:T-10)).*(1+vwretx(3:T-9)).*...
          (1+vwretx(4:T-8)).*(1+vwretx(5:T-7)).*(1+vwretx(6:T-6)).*...
          (1+vwretx(7:T-5)).*(1+vwretx(8:T-4)).*(1+vwretx(9:T-3)).*...
          (1+vwretx(10:T-2)).*(1+vwretx(11:T-1)).*(1+vwretx(12:T));
      
vwdp = vwretda./vwretxa-1; %(P1+D1)/P0 * P0/P1 -1;   
vwdda = vwdp(13:end)./vwdp(1:end-12).*vwretxa(13:end);   % D_t+1/D_t = D_t+1/P_t+1 / D_t/P_t * P_t+1/P_t
vwdda = [ones(23,1)*NaN; vwdda]; % CHECK DD TIMING

vwdp = [ ones(11,1)*NaN; vwdp];

% -------------
% french beme
% -------------

x = load('french_beme.txt'); 
bmyear = x(:,1); 
beme = x(:,2); 

x = load('sumBE_new.txt'); 
sumBE = x(:,2:end);
x = load('sumBEME_new.txt'); 
bmyr2 = x(:,1);
sumBEME = x(:,2:end);
sumME = sumBE./sumBEME;
mktBE = sum(sumBE,2);
mktME = sum(sumME,2);
mktBEME = mktBE./mktME;

figure; % check new data source is same as the old one
plot(bmyear,beme);
hold on
plot(bmyr2,mktBEME,'-r'); 

beme = mktBEME;
bmyear = bmyr2; % it works, use new data

% shiller data

x = load('ie_data_csv.csv'); 
shiller_date = x(:,1); 
yr_s = floor(shiller_date); 
mo_s = 100*shiller_date - 100*yr_s; 
cape = x(:,11); 


% compare valuations

figure; 
plot(crsp_date_number,1./vwdp,'linewidth',2); 
hold on
plot(datenum(bmyear,12,31),20*1./beme,'-r','linewidth',2)
plot(datenum(yr_s,mo_s,1),cape,'-m','linewidth',2);
title('M/B  P/D and CAPE')
legend('20*M/B','P/D)','CAPE',2);
datetick;

% **********
% macro data
% *********

    % total 
    
    x = load('pce.csv');
    yr_c = x(:,1);
    mo_c = x(:,2);
    dy_c = x(:,3);
    ctotal = x(:,4);
    
    x = load('pcepi.csv');
    cpi = x(:,4);
    
    x = load('pop.csv');
    yr_pop = x(:,1);
    mo_pop = x(:,2);
    dy_pop = x(:,3);
    pop = x(:,4);
    ind1 = find((yr_pop==yr_c(1))&(mo_pop == mo_c(1)));
    ind2 = find((yr_pop==yr_c(end))&(mo_pop == mo_c(end)));
    yr_pop = yr_pop(ind1:ind2);
    mo_pop = mo_pop(ind1:ind2);
    dy_pop = dy_pop(ind1:ind2);
    pop = pop(ind1:ind2);
    
    ctotal = (ctotal./(pop.*cpi));

    c = log(ctotal);
    yr = yr_c;
    mo = mo_c;
    dy = dy_c; 

% approximate model
% x_t = phi x_t-1 + (1+g-phi) ct 
% when consumption grows at rate g, steady state is 
% x(1+g) = phi x + (1+g-phi)c
% x = (1+g-phi)c/((1+g)-phi)

% want steady state x = c, ct = c_t-1 + g
%xt = a + phi xt-1 + k ct
%c + g = a + phi c + k c
%g = a
%1 = phi + k 
%k = 1-phi


phi = [ 0.90 ]; 
lphi = length(phi);
x = 0*c*ones(1,lphi); 
x(1,:) = c(1)*ones(1,lphi); 
for t = 2:length(c); 
    x(t,:) = phi.*x(t-1,:) + (1-phi)*c(t); 
end; 

[trash, ind1vw] = min(abs(crsp_date_number-datenum(1990, 01, 31)));
[trash, ind2vw] = min(abs(crsp_date_number- datenum(2015, 12, 31)));

ind1c = find(datenum(yr,mo,dy) == datenum(1990, 02, 01));
ind2c = find(datenum(yr,mo,dy) == datenum(2016, 01, 01));

% match sample dates 
%1990 01 31 = 1990 02 01 
%2015 12 31 = 2016 01 01 


fitcx = 0*x; 

for indx = 1:lphi;
    rhs = c-x(:,indx);
    
    rhs = rhs(ind1c:ind2c,:);
    rhs = [ones(length(rhs),1) rhs];
    lhs = log(1./vwdp(ind1vw:ind2vw));
    b = rhs\lhs;
    fitcx(:,indx)= [ones(length(c),1) c-x(:,indx)]*b;
end;


    figure
    plot(datenum(yr,mo,dy),fitcx,'-r','linewidth',2);
    hold on
    plot(crsp_date_number,log(1./vwdp),'-b','linewidth',2);
    %plot(datenum(yr_s,mo_s,1),log(cape),'-m','linewidth',2);
    axis([datenum(1955,1,1) datenum(2015,12,1) -inf inf]);
    indx = find((yr == 2002)&(mo == 1));
    text(datenum(1980,1,1),4.1,'C-X','Color','r','fontsize',16)
    text(datenum(1995,1,1),3.2,'log(P/D)','Color','b','fontsize',16)
    
    %legend('SPC','P/D',2)
    datetick('keeplimits')
    set(gca,'Ytick',[]);
    print -depsc2 spc.eps
    
    
    figure
    plot(datenum(yr,mo,dy),c,'linewidth',2);
    title(' consumption and habit')
    hold on
    plot(datenum(yr,mo,dy),x,'-r','linewidth',2);
    %axis([datenum(1990,1,1) datenum(2015,12,1) -inf inf]);
    datetick('keeplimits')



% ************************
% investment
% need to merge new and old data
% ************************

x = load('pnfic96.txt');
yrq = x(:,1);
moq = x(:,2);
dyq = x(:,3);
inv = x(:,4);

x = load('pnfic96.csv');

yrq_n = x(:,1);
moq_n = x(:,2);
dyq_n = x(:,3);
inv_n = x(:,4);

indx = find((yrq == yrq_n(1))&( moq == moq_n(1)));
inv = inv + inv_n(1)-inv(indx); 

figure;
plot(datenum(yrq,moq,dyq),inv);
hold on
plot(datenum(yrq_n,moq_n,dyq_n),inv_n);

inv = [inv(1:indx); inv_n]; 
yrq = [yrq(1:indx); yrq_n];
moq = [moq(1:indx); moq_n];
dyq = [dyq(1:indx); dyq_n];

T = size(inv,1);

delta = 0.1/4;
gi = mean(inv(2:T)./inv(1:T-1));
ik = 0*inv;
ik(1) = gi-1+delta;
for t = 2:T; 
    ik(t) = inv(t)/inv(t-1)*(ik(t-1)/((1-delta)+ik(t-1)));
end;

rhs = ik(end-25*4:end,:);
rhs = [ones(size(rhs,1),1) rhs];
lhs = log(1./(vwdp(end-25*12:3:end,:)*20));
b= rhs\lhs;
ikfit = [ones(size(ik,1),1) ik]*b;


figure;
plot(datenum(yrq,moq,dyq),ikfit,'-r','linewidth',2);
hold on;
text(datenum(1982,1,1),0.8,'I/K','color','r','fontsize',16);
%plot(crsp_date_number,spindx./max(spindx),'linewidth',2);
plot(crsp_date_number,log(1./(vwdp*20)),'-b','linewidth',2);
text(datenum(1992,1,1),0.3,'P/(20xD)','color','b','fontsize',16);
plot(datenum(bmyear,12,31),log(1./beme),'--','color',[0 0.5 0],'linewidth',2)
text(datenum(2001,12,1),1.25,'ME/BE','color',[0 0.5 0],'fontsize',16); 
%title('Nonres. Fixed I/K and Q');
%set(gca,'Ytick',[]);
%legend('I/K','P/(20*D)','ME/BE');
axis([datenum(1980,1,1) datenum(2016,1,1) -inf inf]);
datetick('keeplimits');
print -depsc2 ik.eps

